\chapter{Fuzz testing}

\section{Software testing}

Software testing is a process of discovering errors in the code.
The testing process can only demonstrate the misbehaviour of the target, not prove its correctness. There are multiple testing techniques, and there is not one that would discover all the errors. The testing approaches can be classified into 3 basic categories: \textit{white-box}, \textit{gray-box} and \textit{black-box} \cite[p.~3]{fuzzing_book}.

In the \textbf{white-box} approach, the tester can access all the resources used in the program design. The resources include the program design specification, standards, source code, documentation, and even the programmers themselves  \cite[p.~3]{fuzzing_book}. An example of the white-box approach is a source code audit. It can be performed by manually reviewing the code or using static analysis tools. Since purely manual code inspection is very time consuming, a combination of manual and automated analysis is often used. Firstly, static analysis tools scan the source code and identify potential issues. Then a human analysis is used to verify the potential issues manually \cite[p.~4]{fuzzing_book}. The main advantage of the white-box approach is that complete coverage can be easily achieved since the full source code is available. On the other hand, this brings much complexity to the review process, resulting in false positives \cite[p.~9]{fuzzing_book}.

The \textbf{black box} approach is the complete opposite of the white-box approach. It presumes no knowledge of the internal working of the program. The tester is therefore limited to blind testing. He can only interact with an instance of the program and observe the result without knowing what is happening under the hood. An example may be a server application that runs on a remote server to which the tester does not have access \cite[p.~3]{fuzzing_book}. An example of this approach is manual testing, where the tester identifies potential inputs and tries entering edge cases and potentially problematic inputs \cite[p.~10]{fuzzing_book}. Another method is to generate the test cases automatically, also known as fuzz testing, which we will discuss in the next section. The main advantage is simplicity. The tester does not need to examine the target nor reverse engineer the program binary (which requires specialised skills). It is also easy to use the same testing inputs across multiple targets (e.g., web browsers can be tested using the same web page). On the other hand, it is hard to achieve good coverage of the program code (e.g. if the application acts only if a particular character is equal to a constant, there is only a 1 out of 256 chance that the code path will be discovered). More complex attacks consisting of multiple vulnerabilities are also unlikely to be discovered \cite[p.~13]{fuzzing_book}.

The \textbf{gray-box} approach is in the middle between the white-box and black-box approaches. It requires \textit{limited} knowledge of the internal knowledge of the tested system. This may include access to the compiled program, essential documentation, or knowledge of basic components the target consists of \cite[p.~3]{fuzzing_book}. Source code is an irreplaceable resource because it is designed to be easily understood by the programmer or auditor. Additionally, it shows the whole program.

On the other hand, if only the binary is available, it is much more difficult to reverse engineer and discover all the code (as the executable program contains code mixed with data). Despite all of this, binary code is still a great source of information, although more time demanding to uncover. For manual binary auditing, disassemblers and decompilers can transform the binary code into a more human-readable form and help annotate and navigate the disassembled code. A debugger can also be used for dynamic analysis \cite[p.~14]{fuzzing_book}. The main advantage is that binary code or bytecode is almost always available, except for server applications. Information from the binary analysis can aid pure black-box fuzzing techniques to achieve broader coverage. On the other hand, manual binary auditing is very specialised and time-consuming. Therefore, it is not suitable for large programs \cite[p.~18]{fuzzing_book}.

\section{Fuzz testing}


We can define \textbf{fuzz testing} (shortly \textit{fuzzing}) as an automated testing process during which invalid or semi-valid inputs covering numerous boundary cases in the target program are generated. The generated data is passed to the tested program (e.g. as an input file, an API call argument or a network packet) to discover exploitable vulnerabilities \cite{violating_assumptions}.

The first reference to fuzzing came from a University
of Wisconsin-Madison research project in 1990 \cite{empirical}. During a stormy night, the author logged on to his workstation via a dial-up line and observed essential operating utilities crashing due to invalid input caused by noise on the phone line. This led him to design a testing procedure to generate random input, feed it to system utilities, and detect crashes. At the time, the process was primarily focused on increasing the reliability and stability of the programs instead of security \cite[p.~23]{fuzzing_book}.

The tool called \texttt{fuzz} was a relatively simple generator of random inputs. The \texttt{fuzz} utility supported generating either printable or control character sequences or both. The user could specify the delay between the characters and the random number generator seed. The random output was then piped to a system utility and backup if the input was stored in a file (there was also a utility to emulate interactive terminal to fuzz interactive programs). Scripts were included, which checked if there is a \texttt{core} file indicating a crash of the program. Even such a straightforward black-box approach managed to crash 24\% of the tested programs. This was although the programs passed commercial testing procedures, which showed that the technique is indeed viable for discovering bugs \cite{empirical}.

\section{Fuzzing lifecycle}

The fuzzing process can be broken down into multiple stages. Firstly, we need to decide \textit{how to pass data to the program}. We need to locate all possible inputs to the program. It may include files, environment variables or network connections. We may also fuzz only a particular API call or a function from the program (similar to a unit test) \cite[p.~27]{fuzzing_book}.

In the next step we \textit{generate input data}. We can keep generating random inputs or start with valid or random inputs and then mutate and crossover them to obtain new inputs. In the case of white-box or gray-box testing, additional information from the fuzzed target can guide the mutation process (e.g. the input data can be mutated so that the code coverage is maximised).

After generating a new input, we \textit{pass it to the target} according to the input type identified previously and execute the program. While executing the program, we monitor the program to detect program crashes or anomalies. The most straightforward approach is to send some trivial input to the program after each generated test case and verify that the program is still responsive (e.g. sending \texttt{GET} request for the index page of a web server). However, this method is too coarse, and some targets may recover from crashes (e.g. web server, which spawns a per-connection process or a program with registered exception handlers) \cite[p.~171]{fuzzing_miller}.

More sophisticated error detection depends on the specific target  \cite[p.~28]{fuzzing_book}. Running the target with debug logging enabled and observing produced log files can uncover unexpected behaviour like crashes of child processes. Intercepting system calls for file reads and writes before and after executing the test case can detect file changes and potentially uncover unauthorised file access (e.g. by erroneously processing \texttt{"../../../../../etc/passwd"}) \cite[p.~168]{fuzzing_miller}. Memory sanitisers can be used to detect memory corruption for programs written in memory-unsafe programming languages.

Finally, we classify the detected defects and determine their severity. Multiple inputs that cause a crash can trigger the same or similar bug. As the fuzzer can generate numerous test cases, we need to introduce automated methods for deduplication and classification \cite[p.~185]{fuzzing_miller}. To deduplicate crashes, we need to introduce a fingerprint deduced from the program state, which would express when and how the bug was triggered. The bug fingerprint can be neither too detailed nor too general.

The \textbf{bug fingerprint} can be produced by taking several most significant bits from the instruction register (IP) at the time of the crash. This process requires access to a debugger, core dump or logs. The main disadvantage is when the crash occurs in shared code. For example,
the memory copying \texttt{memcpy} function can be called with an invalid pointer from different contexts and different bugs. However, invalid memory access, which causes the crash, will only occur in the \texttt{memcpy} function resulting in the same fingerprint for all the bugs. Another disadvantage is the brittleness of code layout (and therefore also the IP) with regard to changes in the source code and across different compilers and compiler versions. A more robust method is to use the whole stack trace as a fingerprint \cite[p.~186]{fuzzing_miller}. There exist commercial tools for automatic bug deduplication and severity assessment \cite[p.~187]{fuzzing_miller}.

\section{Fuzzer types}

There are two main categories of fuzzers based on how they generate the test cases. The two approaches are \textit{generation} and \textit{mutation} (also called \textit{intelligent} and \textit{nonintelligent} or \textit{full-blown} and \textit{capture-replay} in the context of network fuzzers) \cite[p.~137]{fuzzing_miller}.

\textit{Generation-based} fuzzer generates the test cases from scratch. Therefore, the fuzzer must be designed for the specific file format or protocol and represents white or gray-box testing  \cite[p.~137]{fuzzing_miller}. On the other hand \textit{mutation-based} fuzzer starts with a set of properly-formatted inputs (called a \textit{seed corpus}) and performs modifications on (or \textit{mutates}) them to create new semi-valid inputs. The black-box approach is based on starting with a set of valid inputs and mutating them. Optionally, some internal insight into the program (e.g. code coverage) can provide feedback for guiding the mutation process, which constitutes a gray-box approach  \cite[p.~137]{fuzzing_miller}.

\subsection{Mutation-based fuzzing}

The advantage of mutation fuzzers is that the mutations are format-agnostic (if no format-specific mutator is used). Therefore the same mutation-based fuzzer can be used for fuzzing multiple different file formats \cite[p.~137]{fuzzing_miller}. Mutation-based fuzzer is also easier to get up and running because the user does not need to describe the fuzzed format. He only needs to supply a diverse set of example inputs, which is usually easier to collect than describing the whole file format (supplying files from real-life usage is generally a good starting point). Another advantage is that the mutation-based fuzzer makes no assumptions about the fuzzed format. Making no assumptions leads to discovering bugs in parts of the code that were assumed to be correct and (consciously or unconsciously) excluded from the testing (this was the initial motivation behind introducing fuzz testing  \cite[p.~139]{fuzzing_miller}).

The main disadvantage of mutation-based fuzzers is that they are not aware of the overall structure of the file. Therefore, it takes them a long to discover more complex bugs caused by nontrivial interactions among different input components. It can be illustrated by starting the fuzzer with no seed corpus. It will most likely take a long period before the fuzzer discovers a skeleton of the format (including all the mandatory fields, magic values and the like), and special assistance must be provided for files with checksums (e.g. providing a fuzzer-friendly build option that disables checksums). This hints toward the significant weak spot of mutation-based fuzzers: the quality of the initial set of inputs  \cite[p.~210]{fuzzing_miller}).

\subsection{Generation-based fuzzing}

The generation-based fuzzer must be specifically built for the concrete file format, which requires extra tester time. Such a fuzzer can more quickly build complete and complex test cases. It is not dependent on initial test cases because it is designed to generate them from scratch. The main drawback is that extra tester time is needed to design the generation-based fuzzer. The fuzzer designer has to make assumptions about the format, so some corner cases can be missed. It is estimated that such an intelligent fuzzer is about 50\% more effective in discovering bugs but requires 10 to 100 times more effort by the tester \cite[p.~138]{fuzzing_miller}.

A promising approach is to combine the generation and mutation-based methodologies. For example, a generation-based fuzzer can generate more complex test cases. These test cases can then be used as a seed corpus for a mutation-based fuzzer to uncover other corner-case errors.

\subsection{Evolutionary fuzzing}

\textit{Evolutionary fuzzing} is a testing method based on genetic algorithms. The concepts from evolutionary biology inspire the field of genetic algorithms. The seed corpus is used as the initial generation. Then every member of the generation is tested for fitness. Only the fittest members can breed, and their offsprings form the next generation. Therefore every generation becomes fitter and fitter. The selection and breeding process is repeated until the target, or a dead-end is reached \cite[p.~219]{fuzzing_miller}.

The fitness function consists of two components: approach level and distance. The \textit{approach level} is the number of branching points (e.g. \textit{if} conditions) that must be overcome to reach the target. The distance represents how much (at minimum) must the current value be modified to get past the current branch towards the target. The target can be a specific location in the code or to increase the overall code coverage (i.e. targetting yet untaken branches) \cite[p.~219]{fuzzing_miller}.

After the fittest members are selected from the current generation, they are paired and bred together. The breeding algorithm could be a simple crossover could be used. A pivot dividing the input into two parts can be chosen. The offspring is then produced by taking the first half from the first and the second half from the second parent. Alternatively, multiple pivots can be chosen. After the breeding, randomness can be introduced into the offspring by mutating it (e.g. a bitflip, data insertion or swapping) with some probability \textit{p} \cite[p.~221]{fuzzing_miller}. Elitism can be used, which means that the fittest elements can be transferred into the next generation untouched \cite[p.~224]{fuzzing_miller}.

The key to successful vulnerability discovery is generating inputs not too far but not too close to the format. If the input is completely valid, it will most likely be processed without any error. On the other hand, the execution will end in error handling code if it is severely malformed. The potential of evolutionary fuzzing lies in the fact that it gradually discovers the format or protocol. It keeps making slight mistakes until it discovers the correct parts of the input. If code coverage is used for fitness evaluation, the process starts with a trivial input, possibly halting the program in the first layer of error checking (like checking for a fixed magic value). Every subsequent generation unvails a new layer in the program's control flow. Such a process is ideal because while the produced inputs are not entirely correct, they are also not too corrupted \cite[p.~222]{fuzzing_miller}.
\section{Evaluating fuzzer efficiency}

When integrating fuzz testing into the development process, it is essential to acquire feedback from the fuzzing process. Then we can determine if the fuzzer is efficient in discovering bugs and if the expected parts of the codebase can be reached using the generated inputs.

A helpful tool is to count the number of locations within the program that can be reached by running the fuzzer (called \textit{program coverage}). We need to modify the program to record how many times an instruction on a specific position in the program or a source code line was executed. There exists support in the compilers to emit coverage-tracking code during compilation \cite{clang_coverage}. After the instrumentation, the produced binary saves coverage statistics after every run. These statistics can be mapped back to the source code and visualised.

The number of covered locations has to be compared with the overall size of the program. However, the threat model and the resulting attack surface must be considered when comparing them. The number of covered lines should be compared to the number of lines the potential attacker can reach \cite[p.~253]{fuzzing_miller}.

The fact that a line was covered does not imply that it was thoroughly tested (e.g. a line containing a division of two variables could have been covered by non-null operands, missing a division by zero bug). However, there is strong evidence that increased code coverage correlates with more bugs found using the fuzzer \cite[p.~274]{fuzzing_miller}. Code coverage can be visualised to verify that the fuzzer reaches expected locations. It can reveal that the fuzzer has hit an unsurmountable barrier, such as an integrity checksum.
